#include <time.h>
#define INCL_DOSERRORS
#define INCL_DOSSEMAPHORES
#define INCL_WIN
#include <os2.h>
#include "standby2.h"

#pragma linkage(_DLL_InitTerm, system)

int _CRT_init( void );
void _CRT_term( ULONG flag );

static HEV hev = NULLHANDLE;
extern int pmprintf(const unsigned char *f, ...);

ULONG
_DLL_InitTerm(
HMODULE hmod,
ULONG flag ) {
   APIRET rc = 0;
   switch ( flag ) {
   case 0:
      if ( _CRT_init() == -1 ) {
         return ( 0 );
      } /* endif */
      break;
   case 1:
      rc = DosCloseEventSem( hev );
      _CRT_term( 0 );
      break;
   default:
     break;
   } /* endswitch */
   return ( 1 );
}

BOOL EXPENTRY
InputHook (
HAB hab,
PQMSG pqmsg,
ULONG fs ) {
   switch ( pqmsg->msg ) {
   case WM_CHAR:
   case WM_BUTTON1DOWN:
   case WM_BUTTON2DOWN:
   case WM_BUTTON3DOWN:
      {
         static time_t last = 0;
         time_t curr = time( NULL );
         APIRET rc = 0;
         if ( !hev ) {
            rc = DosOpenEventSem( SemName, &hev );
         } /* endif */
         if ( hev && ( !last || (curr - last) ) ) {
            rc = DosPostEventSem( hev );
            last = curr;
         } /* endif */
      }
     break;
   } /* endswitch */
   return ( FALSE );
}
